import Title from "@/components/Title";
import styles from "./styles.module.scss";
import Answer from "../../components/Answer";
import { useDispatch, useSelector } from "react-redux";
import { actions, selectors } from "@/store";
import { sleep } from "@/services/date";
import { useNavigate } from "react-router-dom";
import routes from "@/routes";
import { answerTimeOut } from "../../data";
import { useTranslations } from "@/hooks/translations";
import { ELocalesPlacement } from "@/locales";
import { useMemo } from "react";
import { useSession } from "@/hooks/session/useSession";
import { IAnswersSessionCompatibilityV4 } from "@/api/resources/Session";
import { ESourceAuthorization } from "@/api/resources/User";

function CalculateInAdvance() {
  const { translate } = useTranslations(ELocalesPlacement.CompatibilityV4);
  const { updateSession } = useSession();
  const navigate = useNavigate();
  const dispatch = useDispatch();
  const { calculateInAdvance } = useSelector(
    selectors.selectCompatibilityV4Answers
  );

  const answers: {
    id: IAnswersSessionCompatibilityV4["calculate_in_advance"];
    title: string;
  }[] = useMemo(
    () => [
      {
        id: "yes",
        title: translate("/calculate-in-advance.answer1"),
      },
      {
        id: "no",
        title: translate("/calculate-in-advance.answer2"),
      },
      {
        id: "yes_may_be",
        title: translate("/calculate-in-advance.answer3"),
      },
      {
        id: "yes_but_not_fate",
        title: translate("/calculate-in-advance.answer4"),
      },
    ],
    [translate]
  );

  const handleClick = async (id: IAnswersSessionCompatibilityV4["calculate_in_advance"]) => {
    dispatch(actions.compatibilityV4Answers.update({ calculateInAdvance: id }));
    updateSession({
      answers: {
        calculate_in_advance: id,
      },
    }, ESourceAuthorization["aura.compatibility.v4"]);
    if (id !== calculateInAdvance) await sleep(answerTimeOut);
    navigate(routes.client.compatibilityV4CalculateInAdvanceResult());
  };

  return (
    <div className={styles.container}>
      <Title variant="h2" className={styles.title}>
        {translate("/calculate-in-advance.title")}
      </Title>
      {answers.map((answers, index) => (
        <Answer
          key={index}
          answer={answers}
          isSelected={calculateInAdvance === answers.id}
          onClick={() => handleClick(answers.id)}
        />
      ))}
    </div>
  );
}

export default CalculateInAdvance;
